#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int n, m;

#define big unsigned long long;

long long sumRows(int b, int e)
{
	long long begin = ((b - 1) * (long long)m + 1);
	long long end = ((long long)e * m);
	return (begin + end) * m * (e - b + 1) / 2;
}

long long sumCols(int b, int e)
{
	long long bcol = (((long long)b * 2 + (n - 1) * (long long)m) * n / 2);
	return (2 * bcol + (e - b) * (long long)n) * (e - b + 1) / 2;
}

void optimizedOnce(char& kind, int& place)
{
	// vert
	int lv = (m + 1) / 2;
	int rv = m;
	long long leftpartv = -1, rightpartv;
	while (rv - lv > 1)
	{
		int mid = (lv + rv) / 2;
		long long leftpart = sumCols(1, mid - 1), rightpart = sumCols(mid, m);
		if (leftpart < rightpart)
			lv = mid;
		else
		{
			rv = mid;
			leftpartv = leftpart;
			rightpartv = rightpart;
		}
	}
	if (leftpartv == -1)
	{
		leftpartv = sumCols(1, rv - 1);
		rightpartv = sumCols(rv, m);
	}
	if (leftpartv == rightpartv)
	{
		kind = 'V';
		place = rv;
		return;
	}
	long long posslv, possrv;
	if (rv > 1 && abs((possrv = sumCols(rv - 1, m)) - (posslv = sumCols(1, rv - 2))) <= abs(leftpartv - rightpartv))
	{
		rv--;
		leftpartv = posslv;
		rightpartv = possrv;
	}

	// horz
	int lh = (n + 1) / 2, rh = n;
	long long leftparth = -1, rightparth;
	while (rh - lh > 1)
	{
		int mid = (rh + lh) / 2;
		long long leftpart = sumRows(1, mid - 1), rightpart = sumRows(mid, n);
		if (leftpart < rightpart)
			lh = mid;
		else
		{
			rh = mid;
			leftparth = leftpart;
			rightparth = rightpart;
		}
	}
	if (leftparth == -1)
	{
		leftparth = sumRows(1, rh - 1);
		rightparth = sumRows(rh, n);
	}
	long long posslh, possrh;
	if (rh > 1 && abs((possrh = sumRows(rh - 1, n)) - (posslh = sumRows(1, rh - 2))) <= abs(leftparth - rightparth))
	{
		rh--;
		leftparth = posslh;
		rightparth = possrh;
	}
	if (abs(rightparth - leftparth) < abs(rightpartv - leftpartv))
	{
		kind = 'H';
		place = rh;
	}
	else
	{
		kind = 'V';
		place = rv;
	}
}

void optimized()
{
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		cin >> n >> m;
		char kind;
		int place;
		optimizedOnce(kind, place);
		cout << kind << ' ' << place << '\n';
	}
}

void naiveOnce(char& kind, int& place)
{
	long long mindiff = 1e18;
	for (int i = 1; i <= m; i++)
	{
		long long diff = abs(sumCols(1, i - 1) - sumCols(i, m));
		if (diff < mindiff)
		{
			mindiff = diff;
			kind = 'V';
			place = i;
		}
	}
	for (int i = 1; i <= n; i++)
	{
		long long diff = abs(sumRows(1, i - 1) - sumRows(i, n));
		if (diff < mindiff)
		{
			mindiff = diff;
			kind = 'H';
			place = i;
		}
	}
}

int main()
{
	/*char nk, ok;
	int np, op;
	for (n = 1000; ; n++)
	{
		for (m = 1000; m <= n; m++)
		{
			naiveOnce(nk, np);
			optimizedOnce(ok, op);
			if (nk != ok || np != op)
			{
				cout << n << ' ' << m << ": correct: " << nk << ' ' << np << '\n';
			}
		}
	}*/
	optimized();
}