﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;

#define pic pair<int, char>
char chars[] = { 'A', 'G', 'C', 'T' };

vector<pic> rle;
vector<int> indices;

void FastIO()
{
	cin.sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

int numlength(int num)
{
	if (num == 1)
		return 0;
	return 1 + floor(log10f(num) + 1);
}

int symCount(pic& p)
{
	return 1 + numlength(p.first);
}

char GetAnother(char a, char b)
{
	for (char ch : chars)
		if (ch != a && ch != b)
			return ch;
}

bool istenpow(int i)
{
	while (i >= 10)
		i /= 10;
	return i == 1;
}

void AsTenpow(int num, int& tenpow, int& rem)
{
	int p = log10f(num);
	tenpow = pow(10, p);
	rem = num - tenpow;
}

void optimized(string fullrle)
{
	int curnum = 0;
	int curindex = 0;
	for (char c : fullrle)
	{
		if (c >= '0' && c <= '9')
		{
			curnum *= 10;
			curnum += c - '0';
			continue;
		}
		if (curnum == 0)
			curnum = 1;
		rle.emplace_back(curnum, c);
		indices.push_back(curindex);
		curindex += curnum;
		curnum = 0;
	}
	int len = fullrle.length();
	int index = 0, maxdecr = 0, maxincr = 0;
	int removeindex = 1;
	int insertindex = -1; char insertchar;
	for (auto& r : rle)
	{
		// decr
		if (r.first == 1)
		{
			if ((index == 0 || index == rle.size() - 1 || rle[index - 1].second != rle[index + 1].second))
			{
				if (maxdecr < 1)
				{
					maxdecr = 1;
					removeindex = indices[index] + 1;

				}
			}
			else
			{
				int decr = 1 + symCount(rle[index - 1]) + symCount(rle[index + 1]);
				pic p;
				p.first = rle[index - 1].first + rle[index + 1].first;
				decr -= symCount(p);
				if (decr > maxdecr)
				{
					maxdecr = decr;
					removeindex = indices[index] + 1;
				}
			}
		}
		else if (istenpow(r.first))
		{
			if (maxdecr < 1)
			{
				maxdecr = 1;
				removeindex = indices[index] + 1;
			}
		}

		//incr
		if (r.first >= 3)
		{
			int tenpow, rem;
			AsTenpow(r.first, tenpow, rem);
			if (rem == 0 || rem == 1 || tenpow == 1)
			{
				tenpow = r.first / 2;
				rem = r.first - tenpow;
			}
			int incr = numlength(tenpow) + 3 + numlength(rem);
			if (incr > maxincr)
			{
				maxincr = incr;
				insertindex = indices[index] + tenpow;
				insertchar = GetAnother(r.second, r.second);
			}
		}

		index++;
	}
	if (insertindex == -1) {
		insertindex = 0;
		insertchar = GetAnother(rle[0].second, rle[0].second);
	}
	cout << "2 " << removeindex << '\n';
	cout << "1 " << insertindex << ' ' << insertchar << '\n';
}

int rlelength(string full)
{
	if (full.length() == 0)
		return 0;
	int result = 0;
	int curcount = 1;
	char prevchar = full[0];
	for (int i = 1; i < full.length(); i++)
	{
		char ch = full[i];
		if (ch != prevchar)
		{
			prevchar = ch;
			result += 1 + floor(log10f(curcount) + 1);
		}
		else
			curcount++;
	}
	result += 1 + floor(log10f(curcount) + 1);
	return result;
}

void naiveMin(string fullrle, int& oper, int& index, char& arg)
{
	int minlen = 1e8;
	
}

int main()
{
	FastIO();
	string fullrle;
	getline(cin, fullrle);
	optimized(fullrle);
}