﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>

using namespace std;

struct Part {
	int m;
	int length;
	int fromLeft;
	int fromRight;
};

int n;
int interval = -1;
vector<Part> parts;
bool* used;
unordered_map<int, vector<int>> fromLeft2Index;
int* answer;

void FastIO()
{
	cin.sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

bool dfs(int i, int depth)
{
	if (depth == n - 1)
	{
		answer[depth] = i;
		return true;
	}
	used[i] = true;
	int neededFromLeft = interval - parts[i].fromRight;
	if (fromLeft2Index.count(neededFromLeft) == 0)
	{
		used[i] = false;
		return false;
	}
	for (int j : fromLeft2Index[neededFromLeft])
		if (!used[j])
			if (dfs(j, depth + 1))
			{
				answer[depth] = i;
				used[i] = false;
				return true;
			}
	used[i] = false;
	return false;
}

int main()
{
	FastIO();
	cin >> n;
	parts.resize(n);
	used = new bool[n];
	for (int i = 0; i < n; i++)
		used[i] = false;
	answer = new int[n];
	for (int i = 0; i < n; i++)
	{
		int m, len;
		cin >> m >> len;
		Part& p = parts[i];
		p.m = m;
		p.length = len;
		cin >> p.fromLeft;
		fromLeft2Index[p.fromLeft].push_back(i);
		p.fromRight = len - p.fromLeft;
		for (int j = 1; j < m; j++)
		{
			int perek;
			cin >> perek;
			int curinterval = perek - (p.length - p.fromRight);
			if (interval == -1)
				interval = curinterval;
			else if (interval != curinterval)
			{
				cout << "No";
				return 0;
			}
			p.fromRight = p.length - perek;
		}
	}
	if (n == 1)
	{
		cout << "Yes\n1";
		return 0;
	}
	bool result = false;
	if (interval == -1)
	{
		for (int i = 0; !result && i < n; i++)
		{
			used[i] = true;
			for (int j = 0; j < n; j++)
				if (j != i)
				{
					interval = parts[j].fromLeft + parts[i].fromRight;
					if (dfs(j, 1))
					{
						answer[0] = i;
						result = true;
						break;
					}
				}
			used[i] = false;
		}
	}
	else
	{
		for (int i = 0; i < n; i++)
			if (dfs(i, 0))
			{
				result = true;
				break;
			}
	}
	if (result)
	{
		cout << "Yes\n";
		for (int i = 0; i < n; i++)
			cout << answer[i] + 1 << ' ';
	}
	else
		cout << "No";
}