﻿#include <iostream>
#include <unordered_map>
#include <string>
using namespace std;

#define pii pair<int, int>

#define big long long

void FastIO()
{
	cin.sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

pii columns[2][2];
int n;

const big mod = 1000000007;

void rec(int depth, bool in, big& counter)
{
	if (depth == n)
	{
		counter += !in;
		if (counter == mod)
			counter = 0;
		return;
	}
	for (int out = depth != n - 1; out >= 0; out--)
	{
		pii& col = columns[in][out];
		if (col.first > col.second)
		{
			col.first--;
			big incounter = 0;
			rec(depth + 1, out, incounter);
			col.first++;
			counter += incounter * (col.first - col.second) % mod;
			counter %= mod;
		}
		if (col.first > 0 && depth != n - 1)
		{
			col.first--; col.second--;
			big incounter = 0;
			rec(depth + 1, out, incounter);
			col.first++; col.second++;
			counter += (incounter * col.second) % mod;
			counter %= mod;
		}
	}
}

int optimized(string& a, string& b, string& c)
{
	columns[0][0] = columns[0][1] = columns[1][0] = columns[1][1] = { 0, 0 };
	for (int i = 0; i < n; i++)
	{
		int ai, bi, ci;
		ai = a[i] - '0';
		bi = b[i] - '0';
		ci = c[i] - '0';
		int sum = ai + bi;
		if (sum % 10 != ci && (sum + 1) % 10 != ci)
			return 0;

		bool out = ci < sum;
		bool in = (sum + 1) % 10 == ci;
		bool has0 = !(ai && bi && ci);
		pii* dest = &columns[in][out];
		dest->first++;
		dest->second += has0;
	}

	big counter = 0;
	rec(0, false, counter);
	return (int)counter;
}

bool nextPerm(int* arr)
{
	int i;
	for (i = n - 2; i >= 0; i--)
		if (arr[i] < arr[i + 1])
		{
			int j;
			for (j = i + 1; j < n; j++)
				if (arr[j] < arr[i])
					break;
			j--;
			swap(arr[i], arr[j]);
			j = i + 1;
			int k = n - 1;
			while (j < k)
			{
				swap(arr[j], arr[k]);
				j++; k--;
			}
			break;
		}
	return i != -1;
}

int naive(string& a, string& b, string& c)
{
	int* p = new int[n];
	for (int i = 0; i < n; i++)
		p[i] = i;
	int counter = 0;
	do
	{
		if (!(a[p[0]] - '0' && b[p[0]] - '0' && c[p[0]] - '0'))
			continue;
		counter++;
		int carry = 0;
		for (int i = n - 1; i >= 0; i--)
		{
			carry += a[p[i]] - '0' + b[p[i]] - '0';
			if (carry % 10 != c[p[i]] - '0')
			{
				counter--;
				break;
			}
			carry /= 10;
		}
		if (counter == mod)
			counter = 0;
	} while (nextPerm(p));
	return counter;
}

int powten(int num)
{
	int result = 1;
	while (num >= 10)
	{
		result *= 10;
		num /= 10;
	}
	return result;
}

string itos(big num)
{
	string result;
	while (num > 0)
	{
		char digit = '0' + num % 10;
		result.append(1, digit);
		num /= 10;
	}
	for (int i = result.length() / 2 - 1; i >= 0; i--)
		swap(result[i], result[result.length() - 1 - i]);
	return result;
}

void test()
{
	for (int i = 0; ; i++)
	{
		for (int j = powten(i); j <= i; j++)
		{
			string c = itos(i + j);
			string a = itos(i); string b = itos(j);
			n = c.length();
			if (n > a.length())
				break;
			if (naive(a, b, c) != optimized(a, b, c))
			{
				cout << a << endl << b << endl << c;
				return;
			}
		}
	}
}

void CheckCorrect()
{
	FastIO();
	string a, b, c;
	cin >> a >> b >> c;
	n = a.length();
	cout << naive(a, b, c) << ' ' << optimized(a, b, c);
}

void Do()
{
	FastIO();
	string a, b, c;
	cin >> a >> b >> c;
	n = a.length();
	cout << optimized(a, b, c);
}

int main()
{
	Do();
}